Attribute VB_Name = "basSubClassWindow"
Option Compare Text
Option Explicit


'Public CMouse As cMouseWheel

Private cMouses As Collection

Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
    (ByVal hWnd As Long, _
    ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long

Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
    (ByVal lpPrevWndFunc As Long, _
     ByVal hWnd As Long, _
     ByVal msg As Long, _
     ByVal wParam As Long, _
     ByVal lParam As Long) As Long
     
Public Const GWL_WNDPROC = -4
Public Const WM_MouseWheel = &H20A

Private Const WM_PAINT = &HF

Private Const WM_MOUSEFIRST = &H200
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208
Private Const WM_MBUTTONDBLCLK = &H209
Private Const WM_MOUSELAST = &H209

Private Const WM_PARENTNOTIFY = &H210
Private Const WM_ENTERMENULOOP = &H211
Private Const WM_EXITMENULOOP = &H212
Private Const WM_NEXTMENU = &H213

Private Const WM_SIZING = &H214
Private Const WM_CAPTURECHANGED = &H215
Private Const WM_MOVING = &H216
Private Const WM_POWERBROADCAST = &H218
Private Const WM_DEVICECHANGE = &H219

Private Const WM_MDICREATE = &H220
Private Const WM_MDIDESTROY = &H221
Private Const WM_MDIACTIVATE = &H222
Private Const WM_MDIRESTORE = &H223
Private Const WM_MDINEXT = &H224
Private Const WM_MDIMAXIMIZE = &H225
Private Const WM_MDITILE = &H226
Private Const WM_MDICASCADE = &H227
Private Const WM_MDIICONARRANGE = &H228
Private Const WM_MDIGETACTIVE = &H229
Private Const WM_MDISETMENU = &H230
Private Const WM_ENTERSIZEMOVE = &H231
Private Const WM_EXITSIZEMOVE = &H232
Private Const WM_DROPFILES = &H233
Private Const WM_MDIREFRESHMENU = &H234


Private Const WM_CUT = &H300
Private Const WM_COPY = &H301
Private Const WM_PASTE = &H302
Private Const WM_CLEAR = &H303
Private Const WM_UNDO = &H304
Private Const WM_RENDERFORMAT = &H305
Private Const WM_RENDERALLFORMATS = &H306
Private Const WM_DESTROYCLIPBOARD = &H307
Private Const WM_DRAWCLIPBOARD = &H308
Private Const WM_PAINTCLIPBOARD = &H309
Private Const WM_VSCROLLCLIPBOARD = &H30A
Private Const WM_SIZECLIPBOARD = &H30B
Private Const WM_ASKCBFORMATNAME = &H30C
Private Const WM_CHANGECBCHAIN = &H30D
Private Const WM_HSCROLLCLIPBOARD = &H30E
Private Const WM_QUERYNEWPALETTE = &H30F
Private Const WM_PALETTEISCHANGING = &H310
Private Const WM_PALETTECHANGED = &H311
Private Const WM_HOTKEY = &H312

Private Const WM_HSCROLL = &H114
Private Const WM_VSCROLL = &H115


Private Const WM_SETCURSOR = &H20
Private Const WM_ERASEBKGND = &H14
Private Const WM_ACTIVATE = &H6
Private Const WM_MOVE = &H3
Private Const WM_SIZE = &H5


' Key State Masks for Mouse Messages
Private Const MK_LBUTTON = &H1
Private Const MK_RBUTTON = &H2
Private Const MK_SHIFT = &H4
Private Const MK_CONTROL = &H8
Private Const MK_MBUTTON = &H10

' Window Styles
Private Const WS_OVERLAPPED = &H0&
Private Const WS_POPUP = &H80000000
Private Const WS_CHILD = &H40000000
Private Const WS_MINIMIZE = &H20000000
Private Const WS_VISIBLE = &H10000000
Private Const WS_DISABLED = &H8000000
Private Const WS_CLIPSIBLINGS = &H4000000
Private Const WS_CLIPCHILDREN = &H2000000
Private Const WS_MAXIMIZE = &H1000000
Private Const WS_CAPTION = &HC00000                  '  WS_BORDER Or WS_DLGFRAME
Private Const WS_BORDER = &H800000
Private Const WS_DLGFRAME = &H400000
Private Const WS_VSCROLL = &H200000
Private Const WS_HSCROLL = &H100000
Private Const WS_SYSMENU = &H80000
Private Const WS_THICKFRAME = &H40000
Private Const WS_GROUP = &H20000
Private Const WS_TABSTOP = &H10000

Private Const WS_MINIMIZEBOX = &H20000
Private Const WS_MAXIMIZEBOX = &H10000

Private Const WS_TILED = WS_OVERLAPPED
Private Const WS_ICONIC = WS_MINIMIZE
Private Const WS_SIZEBOX = WS_THICKFRAME
Private Const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)
Private Const WS_TILEDWINDOW = WS_OVERLAPPEDWINDOW

'
'   Common Window Styles
'  /


Private Const WS_POPUPWINDOW = (WS_POPUP Or WS_BORDER Or WS_SYSMENU)

Private Const WS_CHILDWINDOW = (WS_CHILD)

' Extended Window Styles
Private Const WS_EX_DLGMODALFRAME = &H1&
Private Const WS_EX_NOPARENTNOTIFY = &H4&
Private Const WS_EX_TOPMOST = &H8&
Private Const WS_EX_ACCEPTFILES = &H10&
Private Const WS_EX_TRANSPARENT = &H20&


' NOTE: All Message Numbers below 0x0400 are RESERVED.

' Private Window Messages Start Here:
Private Const WM_USER = &H400



'
'  WM_ACTIVATE state values

Private Const WA_INACTIVE = 0
Private Const WA_ACTIVE = 1
Private Const WA_CLICKACTIVE = 2




Public Function WindowProc(ByVal hWnd As Long, _
    ByVal uMsg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) As Long
    
    Dim cMouse As cMouseWheel
    
    Set cMouse = cMouses(CStr(hWnd))
    
    Select Case uMsg
        
        Case WM_MouseWheel
            cMouse.FireMouseWheel hWnd, uMsg, wParam, lParam
            If cMouse.MouseWheelCancel = False Then
                WindowProc = CallWindowProc(cMouse.PrevWndProc, hWnd, uMsg, wParam, lParam)
            End If
            
        Case WM_MOUSEMOVE
            cMouse.FireMouseMoving hWnd, uMsg, wParam, lParam
            WindowProc = CallWindowProc(cMouse.PrevWndProc, hWnd, uMsg, wParam, lParam)
        
        Case WM_PAINT
            cMouse.FirePaint hWnd, uMsg, wParam, lParam
            WindowProc = CallWindowProc(cMouse.PrevWndProc, hWnd, uMsg, wParam, lParam)
        
        Case WM_HSCROLL
            cMouse.FireHScroll hWnd, uMsg, wParam, lParam
            WindowProc = CallWindowProc(cMouse.PrevWndProc, hWnd, uMsg, wParam, lParam)
       
        Case WM_VSCROLL
            cMouse.FireVScroll hWnd, uMsg, wParam, lParam
            WindowProc = CallWindowProc(cMouse.PrevWndProc, hWnd, uMsg, wParam, lParam)
       
         Case WM_MOVE
            cMouse.FireWinMoving hWnd, uMsg, wParam, lParam
            WindowProc = CallWindowProc(cMouse.PrevWndProc, hWnd, uMsg, wParam, lParam)
       
        
        Case Else
           WindowProc = CallWindowProc(cMouse.PrevWndProc, hWnd, uMsg, wParam, lParam)
    End Select
End Function

Public Function AddCMouse(RHS As cMouseWheel, hWnd As Long)
  If (cMouses Is Nothing) Then
    Set cMouses = New Collection
  End If
  cMouses.Add RHS, CStr(hWnd)
End Function

Public Function RemCMouse(hWnd As Long)
  cMouses.Remove CStr(hWnd)
  If cMouses.Count = 0 Then
    Set cMouses = Nothing
  End If
End Function
